searchNodes=[{"doc":"Read model projections for Commanded using Ecto.Example usagedefmodule Projector do use Commanded.Projections.Ecto, application: MyApp.Application, name: &quot;my-projection&quot;, repo: MyApp.Repo, schema_prefix: &quot;my-prefix&quot;, timeout: :infinity project %Event{}, _metadata, fn multi -&gt; Ecto.Multi.insert(multi, :my_projection, %MyProjection{...}) end project %AnotherEvent{}, fn multi -&gt; Ecto.Multi.insert(multi, :my_projection, %MyProjection{...}) end endGuidesGetting startedUsage","ref":"Commanded.Projections.Ecto.html","title":"Commanded.Projections.Ecto","type":"behaviour"},{"doc":"The optional after_update/3 callback function defined in a projector is called after each projected event.The function receives the event, its metadata, and all changes from the Ecto.Multi struct that were executed within the database transaction.You could use this function to notify subscribers that the read model has been updated, such as by publishling changes via Phoenix PubSub channels.Exampledefmodule MyApp.ExampleProjector do use Commanded.Projections.Ecto, application: MyApp.Application, repo: MyApp.Projections.Repo, name: &quot;MyApp.ExampleProjector&quot; project %AnEvent{name: name}, fn multi -&gt; Ecto.Multi.insert(multi, :example_projection, %ExampleProjection{name: name}) end @impl Commanded.Projections.Ecto def after_update(event, metadata, changes) do # Use the event, metadata, or `Ecto.Multi` changes and return `:ok` :ok end end","ref":"Commanded.Projections.Ecto.html#c:after_update/3","title":"Commanded.Projections.Ecto.after_update/3","type":"callback"},{"doc":"Project a domain event into a read model by appending one or more operations to the Ecto.Multi struct passed to the projection function you defineThe operations will be executed in a database transaction including an idempotency check to guarantee an event cannot be projected more than once.Exampleproject %AnEvent{}, fn multi -&gt; Ecto.Multi.insert(multi, :my_projection, %MyProjection{...}) end","ref":"Commanded.Projections.Ecto.html#project/2","title":"Commanded.Projections.Ecto.project/2","type":"macro"},{"doc":"Project a domain event and its metadata map into a read model by appending one or more operations to the Ecto.Multi struct passed to the projection function you define.The operations will be executed in a database transaction including an idempotency check to guarantee an event cannot be projected more than once.Exampleproject %AnEvent{}, metadata, fn multi -&gt; Ecto.Multi.insert(multi, :my_projection, %MyProjection{...}) end","ref":"Commanded.Projections.Ecto.html#project/3","title":"Commanded.Projections.Ecto.project/3","type":"macro"},{"doc":"The optional schema_prefix/1 callback function defined in a projector is used to set the schema of the projection_versions table used by the projector for idempotency checks.It is passed the event and its metadata and must return the schema name, as a string, or nil.","ref":"Commanded.Projections.Ecto.html#c:schema_prefix/1","title":"Commanded.Projections.Ecto.schema_prefix/1","type":"callback"},{"doc":"The optional schema_prefix/2 callback function defined in a projector is used to set the schema of the projection_versions table used by the projector for idempotency checks.It is passed the event and its metadata, and must return the schema name, as a string, or nil","ref":"Commanded.Projections.Ecto.html#c:schema_prefix/2","title":"Commanded.Projections.Ecto.schema_prefix/2","type":"callback"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Allow exceptions to be rescued by Commanded's event handler (#37).","ref":"changelog.html#v1-2-1","title":"Changelog - v1.2.1","type":"extras"},{"doc":"Support runtime projector names (#32).Support schema_prefix/2 function (#33).","ref":"changelog.html#v1-2-0","title":"Changelog - v1.2.0","type":"extras"},{"doc":"EnhancementsDynamic schema prefix (#28).Support Commanded v1.1.0.","ref":"changelog.html#v1-1-0","title":"Changelog - v1.1.0","type":"extras"},{"doc":"EnhancementsSupport multiple Commanded apps (#25).Add .formatter.exs to Hex package (#19).Add microseconds to timestamp fields in projection_versions (#22).","ref":"changelog.html#v1-0-0","title":"Changelog - v1.0.0","type":"extras"},{"doc":"EnhancementsUpgrade to Ecto v3 (#17).Use lambda instead of unhygienic var in projection macros (#13).Previously magic multi:project %AnEvent{name: name}, _metadata do Ecto.Multi.insert(multi, :example_projection, %ExampleProjection{name: name}) endNow multi is provided as a argument to the project function:project %AnEvent{name: name}, _metadata, fn multi -&gt; Ecto.Multi.insert(multi, :example_projection, %ExampleProjection{name: name}) endThe previous do block approach is still supported, but has been deprecated. It will be removed in the next release.","ref":"changelog.html#v0-8-0","title":"Changelog - v0.8.0","type":"extras"},{"doc":"Bug fixesEnsure errors encountered while building the Ecto.Multi data structure within a project function are caught and passed to the error/3 callback.","ref":"changelog.html#v0-7-1","title":"Changelog - v0.7.1","type":"extras"},{"doc":"EnhancementsSupport Commanded's event handler error/3 callback (#12).","ref":"changelog.html#v0-7-0","title":"Changelog - v0.7.0","type":"extras"},{"doc":"EnhancementsPass through any additional projector configuration options to Commanded event handler. Allows new Commanded features to be used without updating this library (e.g. specify consistency option).","ref":"changelog.html#v0-6-0","title":"Changelog - v0.6.0","type":"extras"},{"doc":"EnhancementsAllow an Ecto schema prefix to be defined in config or per handler (#4).","ref":"changelog.html#v0-5-0","title":"Changelog - v0.5.0","type":"extras"},{"doc":"EnhancementsAdd repo option to Commanded.Projections.Ecto macro (#1).Optional after_update/3 callback function in projectors.","ref":"changelog.html#v0-4-0","title":"Changelog - v0.4.0","type":"extras"},{"doc":"Getting startedYou should already have Ecto installed and configured before proceeding. Please follow Ecto's Getting Started guide to get going first.Add commanded_ecto_projections to your list of dependencies in mix.exs: def deps do [{:commanded_ecto_projections, &quot;~&gt; 1.2&quot;}] endGenerate an Ecto migration in your app: $ mix ecto.gen.migration create_projection_versionsModify the generated migration, in priv/repo/migrations, to create the projection_versions table: defmodule CreateProjectionVersions do use Ecto.Migration def change do create table(:projection_versions, primary_key: false) do add(:projection_name, :text, primary_key: true) add(:last_seen_event_number, :bigint) timestamps(type: :naive_datetime_usec) end end endRun the Ecto migration: $ mix ecto.migrateDefine your first read model projector: defmodule MyApp.ExampleProjector do use Commanded.Projections.Ecto, application: MyApp.Application, repo: MyApp.Projections.Repo, name: &quot;example_projection&quot; endRefer to the Usage guide for more detail on how to configure and use a read model projector.","ref":"getting-started.html","title":"Getting started","type":"extras"},{"doc":"Usage","ref":"usage.html","title":"Usage","type":"extras"},{"doc":"Use Ecto.Schema to define one or more read models:defmodule ExampleProjection do use Ecto.Schema schema &quot;example_projections&quot; do field(:name, :string) end end","ref":"usage.html#creating-a-read-model","title":"Usage - Creating a read model","type":"extras"},{"doc":"For each read model you will need to define a module that uses the Commanded.Projections.Ecto module and projects the appropriate domain events with the project macro.You must specify the following options when defining or starting an Ecto projector::application - (module or atom) the Commanded application (e.g. MyApp.Application).:name - (string) a unique name used to identify the event store subscription used by the projector.:repo - (module) an Ecto repo (e.g. MyApp.Projections.Repo).Once a projector has been deployed you should not change its name. Doing so will cause a new event store subscription to be created and replay all existing events.Note: A read model projector is just a specialised Commanded event handler GenServer process.Exampledefmodule MyApp.ExampleProjector do use Commanded.Projections.Ecto, application: MyApp.Application, repo: MyApp.Projections.Repo, name: &quot;example_projection&quot; project %AnEvent{name: name}, _metadata, fn multi -&gt; Ecto.Multi.insert(multi, :example_projection, %ExampleProjection{name: name}) end project %AnotherEvent{name: name}, fn multi -&gt; Ecto.Multi.insert(multi, :example_projection, %ExampleProjection{name: name}) end endRuntime configurationThe :application and :name options can be provided at runtime, but :repo must be specified at compile-time.defmodule MyApp.ExampleProjector do use Commanded.Projections.Ecto, repo: MyApp.Projections.Repo endStarted with:{:ok, pid} = ExampleProjector.start_link(application: MyApp.Application, name: &quot;example_projection&quot;)Or supervised:Supervisor.start_link([ {ExampleProjector, application: MyApp.Application, name: &quot;example_projection&quot;} ], strategy: :one_for_one)Runtime configuration allows the same projector to be run more than once, with each instance using a separate application or name:Supervisor.start_link([ {ExampleProjector, application: App1, name: &quot;App1.Projector&quot;}, {ExampleProjector, application: App2, name: &quot;App2.Projector&quot;} ], strategy: :one_for_one)Using the project macroThe project/3 macro expects the domain event, metadata, and a single-arity function that takes and returns an Ecto.Multi data structure for grouping multiple Repo operations. These will all be executed within a single transaction. You can use Ecto.Multi to insert, update, and delete data.ExamplesProject an event and its metadata into a read model with project/3:project %AnEvent{name: name}, metadata, fn multi -&gt; projection = %ExampleProjection{name: name, metadata: metadata} Ecto.Multi.insert(multi, :example_projection, projection) endUse project/2 if you do not need to use the event metadata:project %AnotherEvent{name: name}, fn multi -&gt; Ecto.Multi.insert(multi, :example_projection, %ExampleProjection{name: name}) endIf you want to skip a projection event, you can return the multi transaction without further modifying it:project %ItemUpdated{uuid: uuid} = event, _metadata, fn multi -&gt; case Repo.get(ItemProjection, uuid) do nil -&gt; multi item -&gt; Ecto.Multi.update(multi, :item, update_changeset(event, item)) end end","ref":"usage.html#creating-a-projector","title":"Usage - Creating a projector","type":"extras"},{"doc":"Your projector module must be included in your application supervision tree:defmodule MyApp.Projections.Supervisor do use Supervisor def start_link(init_arg) do Supervisor.start_link(__MODULE__, init_arg, name: __MODULE__) end @impl true def init(_init_arg) do children = [ MyApp.ExampleProjector ] Supervisor.init(children, strategy: :one_for_one) end endWarning: You should implement an error handling strategy in your projector module when supervising to prevent problematic events from causing cascading errors due too many restarts.","ref":"usage.html#supervision","title":"Usage - Supervision","type":"extras"},{"doc":"error/3 callbackThe Commanded.Projections.Ecto macro defines a Commanded event handler which means you can take advantage of the error/3 callback function to handle any errors returned from a project function. The error function is passed the error returned by the event handler (e.g. {:error, error}), the event causing the error, and a context map containing state passed between retries. Use the context map to track any transient state you need to access between retried failures, such as the number of failed attempts.You can return one of the following responses depending upon the error severity:{:retry, context} - retry the failed event, provide a context map containing any state passed to subsequent failures. This could be used to count the number of failures, stopping after too many.{:retry, delay, context} - retry the failed event, after sleeping for the requested delay (in milliseconds). Context is a map as described in {:retry, context} above.:skip - skip the failed event by acknowledging receipt.{:stop, reason} - stop the projector with the given reason.Error handling exampleHere's an example projector module where an error tagged tuple is explicitly returned from a project function, but you can also handle exceptions caused by faulty Ecto.Multi database operations in a similar manner since the errors are caught and returned as tagged tuples (e.g. {:error, %Ecto.ConstraintError{}}).defmodule MyApp.ExampleProjector do use Commanded.Projections.Ecto, application: MyApp.Application, repo: MyApp.Projections.Repo, name: &quot;MyApp.ExampleProjector&quot; require Logger alias Commanded.Event.FailureContext project %AnEvent{}, fn _multi -&gt; {:error, :failed} end def error({:error, :failed}, %AnEvent{}, %FailureContext{}) do :skip end def error({:error, %Ecto.ConstraintError{} = error}, _event, _failure_context) do Logger.error(fn -&gt; &quot;Failed due to constraint error: &quot; &lt;&gt; inspect(error) end) :skip end def error({:error, _error}, _event, _failure_context) do :skip end endafter_update/3 callbackYou can define an after_update/3 callback function in a projector to be called after each projected event. The function receives the event, its metadata, and all changes from the Ecto.Multi struct that were executed within the database transaction.defmodule MyApp.ExampleProjector do use Commanded.Projections.Ecto, application: MyApp.Application, repo: MyApp.Projections.Repo, name: &quot;MyApp.ExampleProjector&quot; project %AnEvent{name: name}, fn multi -&gt; Ecto.Multi.insert(multi, :example_projection, %ExampleProjection{name: name}) end @impl Commanded.Projections.Ecto def after_update(event, metadata, changes) do # Use the event, metadata, or `Ecto.Multi` changes and return `:ok` :ok end endYou could use this function to notify subscribers that the read model has been updated (e.g. pub/sub to Phoenix channels).","ref":"usage.html#error-handling","title":"Usage - Error handling","type":"extras"},{"doc":"When using a prefix for your Ecto schemas you might also want to change the prefix for the ProjectionVersion schema. There are a number of options to do this:Define a global static prefix via environment config: # config/config.exs config :commanded_ecto_projections, schema_prefix: &quot;example_schema_prefix&quot;Provide a static schema_prefix as a projector option: defmodule MyApp.ExampleProjector do use Commanded.Projections.Ecto, application: MyApp.Application, repo: MyApp.Projections.Repo, name: &quot;example_projection&quot;, schema_prefix: &quot;example_schema_prefix&quot; endProvide a one-arity function as a schema_prefix projector option: defmodule MyApp.ExampleProjector do use Commanded.Projections.Ecto, application: MyApp.Application, repo: MyApp.Projections.Repo, name: &quot;example_projection&quot;, schema_prefix: fn event -&gt; &quot;example_schema_prefix&quot; end end The function will receive the event as the single argument allowing you to use the same or a different schema for each event.Provide a two-arity function as a schema_prefix projector option: defmodule MyApp.ExampleProjector do use Commanded.Projections.Ecto, application: MyApp.Application, repo: MyApp.Projections.Repo, name: &quot;example_projection&quot;, schema_prefix: fn event, metadata -&gt; &quot;example_schema_prefix&quot; end end The function will receive the event and its associated metadata as the two arguments allowing you to use the same or a different schema for each event. The metadata will also include the enriched fields such as the application, event handler name, and optional handler state.Define a schema_prefix/1 callback function: defmodule MyApp.ExampleProjector do use Commanded.Projections.Ecto, application: MyApp.Application, name: &quot;example_projection&quot; @impl Commanded.Projections.Ecto def schema_prefix(event), do: &quot;example_schema_prefix&quot; end The function will receive the event as the single argument allowing you to use the same or a different schema for each event. An example usage could be for tenant specific projections where each tenant's data is projected and stored in a separate database schema: @impl Commanded.Projections.Ecto def schema_prefix(%_{tenant: tenant}), do: tenantDefine a schema_prefix/2 callback function: defmodule MyApp.ExampleProjector do use Commanded.Projections.Ecto, application: MyApp.Application, name: &quot;example_projection&quot; @impl Commanded.Projections.Ecto def schema_prefix(event, metadata), do: &quot;example_schema_prefix&quot; end The function will receive the event and its associated metadata as the two arguments allowing you to use the same or a different schema for each event. The metadata will also include the enriched fields such as the application, event handler name, and optional handler state. An example usage could be for tenant specific projections where each tenant's data is projected and stored in a separate database schema: @impl Commanded.Projections.Ecto def schema_prefix(%_{tenant: tenant}, _metadata), do: tenantMigrations with a schema prefixGenerate an Ecto migration in your app: mix ecto.gen.migration create_schema_projection_versionsModify the generated migration, in priv/repo/migrations, to create the schema and a projection_versions table for the schema: defmodule CreateSchemaProjectionVersions do use Ecto.Migration def up do execute(&quot;CREATE SCHEMA example_schema_prefix&quot;) create table(:projection_versions, primary_key: false, prefix: &quot;example_schema_prefix&quot;) do add(:projection_name, :text, primary_key: true) add(:last_seen_event_number, :bigint) timestamps(type: :naive_datetime_usec) end end def down do drop(table(:projection_versions, prefix: &quot;example_schema_prefix&quot;)) execute(&quot;DROP SCHEMA example_schema_prefix CASCADE&quot;) end end Note you will need to do this for each schema prefix you use.","ref":"usage.html#schema-prefix","title":"Usage - Schema prefix","type":"extras"},{"doc":"The projection_versions table is used to ensure that events are only projected once.To rebuild a projection you will need to:Delete the row containing the last seen event for the projection name: DELETE FROM projection_versions WHERE projection_name = 'example_projection';Truncate the tables that are being populated by the projection, and restart their identity: TRUNCATE TABLE example_projections, other_projections RESTART IDENTITY;You will also need to reset the event store subscription for the commanded event handler. This is specific to whichever event store you are using.","ref":"usage.html#rebuilding-a-projection","title":"Usage - Rebuilding a projection","type":"extras"}]